Index: django/test/simple.py
===================================================================
--- django/test/simple.py	(revision 11574)
+++ django/test/simple.py	(working copy)
@@ -10,6 +10,26 @@
 
 doctestOutputChecker = OutputChecker()
 
+class DjangoTestRunner(unittest.TextTestRunner):
+    
+    def __init__(self, verbosity=0, failfast=False, **kwargs):
+        super(DjangoTestRunner, self).__init__(verbosity=verbosity, **kwargs)
+        self.failfast = failfast
+        
+    def _makeResult(self):
+        result = super(DjangoTestRunner, self)._makeResult()
+        failfast = self.failfast
+        
+        def stoptest_override(func):
+            def stoptest(test):
+                if failfast and not result.wasSuccessful():
+                    result.stop()
+                func(test)
+            return stoptest
+        
+        setattr(result, 'stopTest', stoptest_override(result.stopTest))
+        return result
+
 def get_tests(app_module):
     try:
         app_path = app_module.__name__.split('.')[:-1]
@@ -146,7 +166,7 @@
         bins[0].addTests(bins[i+1])
     return bins[0]
 
-def run_tests(test_labels, verbosity=1, interactive=True, extra_tests=[]):
+def run_tests(test_labels, verbosity=1, interactive=True, failfast=False, extra_tests=[]):
     """
     Run the unit tests for all the test labels in the provided list.
     Labels must be of the form:
@@ -189,7 +209,7 @@
     old_name = settings.DATABASE_NAME
     from django.db import connection
     connection.creation.create_test_db(verbosity, autoclobber=not interactive)
-    result = unittest.TextTestRunner(verbosity=verbosity).run(suite)
+    result = DjangoTestRunner(verbosity=verbosity, failfast=failfast).run(suite)
     connection.creation.destroy_test_db(old_name, verbosity)
 
     teardown_test_environment()
Index: django/core/management/commands/test.py
===================================================================
--- django/core/management/commands/test.py	(revision 11574)
+++ django/core/management/commands/test.py	(working copy)
@@ -6,6 +6,8 @@
     option_list = BaseCommand.option_list + (
         make_option('--noinput', action='store_false', dest='interactive', default=True,
             help='Tells Django to NOT prompt the user for input of any kind.'),
+        make_option('--failfast', action='store_true', dest='failfast', default=False,
+            help='Tells Django to stop running the test suite after first failed test.')
     )
     help = 'Runs the test suite for the specified applications, or the entire site if no apps are specified.'
     args = '[appname ...]'
@@ -15,11 +17,13 @@
     def handle(self, *test_labels, **options):
         from django.conf import settings
         from django.test.utils import get_runner
-
+        
         verbosity = int(options.get('verbosity', 1))
         interactive = options.get('interactive', True)
+        failfast = options.get('failfast', True)
         test_runner = get_runner(settings)
 
-        failures = test_runner(test_labels, verbosity=verbosity, interactive=interactive)
+        failures = test_runner(test_labels, verbosity=verbosity, interactive=interactive, 
+                               failfast=failfast)
         if failures:
             sys.exit(failures)
Index: tests/regressiontests/test_runner/__init__.py
===================================================================
Index: tests/regressiontests/test_runner/tests.py
===================================================================
--- tests/regressiontests/test_runner/tests.py	(revision 0)
+++ tests/regressiontests/test_runner/tests.py	(revision 0)
@@ -0,0 +1,29 @@
+"""
+Tests for django test runner
+"""
+import StringIO
+import unittest
+import django
+from django.test import TestCase, TransactionTestCase, simple 
+
+class DjangoTestRunnerTests(TestCase):
+    
+    def test_failfast(self):
+        class MockTestOne(TransactionTestCase):
+            def runTest(self):
+                assert False
+        class MockTestTwo(TransactionTestCase):
+            def runTest(self):
+                assert False
+                
+        suite = unittest.TestSuite([MockTestOne(), MockTestTwo()])
+        mock_stream = StringIO.StringIO()
+        dtr = simple.DjangoTestRunner(verbosity=0, failfast=False, stream=mock_stream)
+        result = dtr.run(suite)
+        self.assertEqual(2, result.testsRun)
+        self.assertEqual(2, len(result.failures))
+        
+        dtr = simple.DjangoTestRunner(verbosity=0, failfast=True, stream=mock_stream)
+        result = dtr.run(suite)
+        self.assertEqual(1, result.testsRun)
+        self.assertEqual(1, len(result.failures))
\ No newline at end of file
Index: tests/regressiontests/test_runner/models.py
===================================================================
Index: tests/runtests.py
===================================================================
--- tests/runtests.py	(revision 11574)
+++ tests/runtests.py	(working copy)
@@ -85,7 +85,7 @@
         self.assert_(not unexpected, "Unexpected Errors: " + '\n'.join(unexpected))
         self.assert_(not missing, "Missing Errors: " + '\n'.join(missing))
 
-def django_tests(verbosity, interactive, test_labels):
+def django_tests(verbosity, interactive, failfast, test_labels):
     from django.conf import settings
 
     old_installed_apps = settings.INSTALLED_APPS
@@ -158,7 +158,8 @@
         settings.TEST_RUNNER = 'django.test.simple.run_tests'
     test_runner = get_runner(settings)
 
-    failures = test_runner(test_labels, verbosity=verbosity, interactive=interactive, extra_tests=extra_tests)
+    failures = test_runner(test_labels, verbosity=verbosity, interactive=interactive, failfast=failfast,
+                           extra_tests=extra_tests)
     if failures:
         sys.exit(failures)
 
@@ -180,6 +181,8 @@
         help='Verbosity level; 0=minimal output, 1=normal output, 2=all output')
     parser.add_option('--noinput', action='store_false', dest='interactive', default=True,
         help='Tells Django to NOT prompt the user for input of any kind.')
+    parser.add_option('--failfast', action='store_true', dest='failfast', default=False,
+        help='Tells Django to stop running the test suite after first failed test.')
     parser.add_option('--settings',
         help='Python path to settings module, e.g. "myproject.settings". If this isn\'t provided, the DJANGO_SETTINGS_MODULE environment variable will be used.')
     options, args = parser.parse_args()
@@ -188,4 +191,4 @@
     elif "DJANGO_SETTINGS_MODULE" not in os.environ:
         parser.error("DJANGO_SETTINGS_MODULE is not set in the environment. "
                       "Set it or use --settings.")
-    django_tests(int(options.verbosity), options.interactive, args)
+    django_tests(int(options.verbosity), options.interactive, options.failfast, args)
Index: docs/ref/django-admin.txt
===================================================================
--- docs/ref/django-admin.txt	(revision 11574)
+++ docs/ref/django-admin.txt	(working copy)
@@ -689,6 +689,12 @@
 "Are you sure?" confirmation messages. This is useful if ``django-admin.py``
 is being executed as an unattended, automated script.
 
+--failfast
+~~~~~~~~
+
+Use the ``--failfast`` option to stop running tests and report the failure 
+immediately after a test fails.
+
 testserver <fixture fixture ...>
 --------------------------------
 